/*
 * Copyright (c) 2002 by Tsuyoshi Iguchi (zinnia@risky-safety.org)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	$Id: property.h,v 1.2.2.1 2002/05/24 12:02:39 zinnia Exp $
 */

#ifndef __SDL_FLIP_PROPERTY_H
#define __SDL_FLIP_PROPERTY_H

typedef struct {
  char* key;
  char* desc;
  void (*setter)(char* value);
} flip_property;

#define DECLARE_VARIABLE(type,name,value) static type name = value
#define DECLARE_SETTER(type,name) static void set##name(char* _##name){ name = to##type(_##name); }


#define DECLARE_PROPERTY(type,name,value) DECLARE_VARIABLE(type,name,value); DECLARE_SETTER(type,name)
#define PROPERTY_VECTOR_BEGIN static flip_property vector[] = { 
#define DECLARE_VECTOR(name,desc) { #name, desc, set##name, }
#define PROPERTY_VECTOR_END { NULL, NULL, NULL}, \
}; \
static void property_init(){ \
  flip_property_init(vector); \
}


typedef char* string;

int toint(char*);
char* tostring(char*);

void flip_property_init(flip_property*);

int flip_set_property(char*, char*);
int flip_set_property_expression(char*);

#endif
